#include "mh32f10x.h"
#include <stdio.h>
#include "bsp_sdio_sdcard.h"
#include "sdio_test.h"
#include "delay.h"
#include "ff.h"

void USART_Config(uint32_t bound);
uint8_t GetCmd(void);
void TestList(void);
void ShowCardInfo(void);
void FatfsTest(void);
void WriteFileTest(void);
void CreateDir(void);
void DeleteDirFile(void);
void ViewRootDir(void);

extern uint32_t CSD_Tab[4], CID_Tab[4];
extern SD_CardInfo SDCardInfo;
/**
FATFSҪı
*/
FATFS fs;					   //FATFSļϵͳ
FIL fnew;					   //ļ
FRESULT res_sd;                //ļ
UINT fnum;            		   //ļɹд
BYTE ReadBuffer[1024]={0};     //
BYTE WriteBuffer[] =  "MEGAHUNTѶ΢  ------>  ½ļϵͳļ\n";       //д

/**
ڲԶдٶ
**/
#define TEST_FILE_LEN	(2*1024*1024)	//ڲԵļ
#define	BUF_SIZE			(4*1024)	//ÿζдSDݳ
uint8_t TestBuf[BUF_SIZE];

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "delay.h"
#include "mh32f10x.h"

#define PRINTF_LOG 	printf


USART_TypeDef* USART_TEST = USART1;

void UART_Configuration(uint32_t bound);

int main(void)
{	
	uint8_t cmd = 0;
	RCC_ClocksTypeDef clocks;
	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_CRC,ENABLE);
	Delay_Init();
	UART_Configuration(115200);
	RCC_GetClocksFreq(&clocks);
	
	PRINTF_LOG("\n");
	PRINTF_LOG("SYSCLK: %3.1fMhz, HCLK: %3.1fMhz, PCLK1: %3.1fMhz, PCLK2: %3.1fMhz, ADCCLK: %3.1fMhz\n", \
	(float)clocks.SYSCLK_Frequency/1000000, (float)clocks.HCLK_Frequency/1000000, \
	(float)clocks.PCLK1_Frequency/1000000, (float)clocks.PCLK2_Frequency / 1000000, (float)clocks.ADCCLK_Frequency / 1000000);
	
	PRINTF_LOG("MH2103 SDIO SD Card Fatfs Test.\n");
	TestList();

	while(1)
	{
		cmd = GetCmd();
		switch(cmd)
		{
			case '1':
			{
				PRINTF_LOG("1.--->>>FatfsTest\r\n");
				FatfsTest();
				TestList();
				break;
			}
			case '2':
			{
				PRINTF_LOG("2.--->>>ViewRootDir\r\n");
				ViewRootDir();
				TestList();
				break;
			}
			case '3':
			{
				PRINTF_LOG("3.--->>>CreateDir\r\n");
				CreateDir();
				TestList();
				break;
			}
			case '4':
			{
				PRINTF_LOG("4.--->>>DeleteDirFile\r\n");
				DeleteDirFile();
				TestList();
				break;
			}
		}
	}
}

void TestList(void)
{
	PRINTF_LOG("/***************************SD Card Test*******************************/\n");
	PRINTF_LOG("==========================List==========================\n");
	PRINTF_LOG("1: һļ(FatFsдļ.txt),жд\n");
	PRINTF_LOG("2: ʾSD Card Ŀ¼µļ\n");
	PRINTF_LOG("3: Ŀ¼(/Dir1,/Dir1/Die1_1,/Dir2)\n");
	PRINTF_LOG("4: ɾļĿ¼(/Dir1,/Dir1/Dir1_1,/Dir2,FatFsдļ.txt)\n");
	PRINTF_LOG("****************************************************************************/\n");
}

uint8_t GetCmd(void)
{
	uint8_t tmp = 0;

	if(USART_GetFlagStatus(USART1,USART_FLAG_RXNE))
	{
		tmp = USART_ReceiveData(USART1);
	}
	return tmp;
}

 void UART_Configuration(uint32_t bound)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1,ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;	
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	USART_InitStructure.USART_BaudRate = bound;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

	USART_Init(USART_TEST, &USART_InitStructure);
	USART_Cmd(USART_TEST, ENABLE);
}

void FatfsTest(void)
{
	res_sd = f_mount(&fs,"0:",1);
	
	/***************************ʽ**************************/
	PRINTF_LOG("\nʽ\n");
	if(res_sd == FR_NO_FILESYSTEM)
	{
		PRINTF_LOG("SD ûļϵͳ, иʽ\r\n");
	
		res_sd=f_mkfs("0:",0,0);							

		if(res_sd == FR_OK)
		{
			PRINTF_LOG("SD ɹļϵͳ\r\n");
			res_sd = f_mount(NULL,"0:",1);			
			res_sd = f_mount(&fs,"0:",1);
		}
		else
		{
			PRINTF_LOG("SD ʽʧ\r\n");
			while(1);
		}
	}
	else if(res_sd!=FR_OK)
	{
		PRINTF_LOG("SD ʧ (%d), SDʼʧ\r\n",res_sd);
		while(1);
	}
	else
	{
		PRINTF_LOG("ļϵͳس, Խжд\r\n");
	}
	
	/***************************ļϵͳ --->>> д*********************/
	PRINTF_LOG("\nļϵͳ --->>> д\n");
	res_sd = f_open(&fnew, "0:FatFsдļ.txt",FA_OPEN_ALWAYS | FA_WRITE | FA_READ );
	if ( res_sd == FR_OK )
	{
		PRINTF_LOG("/ FatFsдļ.txt ɹ, ļд\r\n");
  
		res_sd=f_write(&fnew,WriteBuffer,sizeof(WriteBuffer),&fnum);
		if(res_sd==FR_OK)
		{
			PRINTF_LOG("ļдɹ, дֽ%d дΪ: \n%s\r\n",fnum,WriteBuffer);
		}
		else
		{
			PRINTF_LOG("ļдʧ (%d)\n",res_sd);
		}    
		f_close(&fnew);
	}
	else
	{	
		PRINTF_LOG("/ ļʧ\r\n");
	}	
	
	/*************************ļϵͳ --->>> **************************/
	PRINTF_LOG("\nļϵͳ --->>> \n");
	res_sd = f_open(&fnew, "0:FatFsдļ.txt", FA_OPEN_ALWAYS | FA_READ); 	 
	if(res_sd == FR_OK)
	{
		PRINTF_LOG("ļɹ\r\n");
		res_sd = f_read(&fnew, ReadBuffer, sizeof(ReadBuffer), &fnum); 
		if(res_sd==FR_OK)
		{
			PRINTF_LOG("ļȡɹ. ȡֽ:%d ȡΪ: \n%s\r\n",fnum,ReadBuffer);
		}
		else
		{
			PRINTF_LOG("ļȡʧ (%d)\n",res_sd);
		}		
	}
	else
	{
		PRINTF_LOG("ļʧ\n");
	}

	f_close(&fnew);	
  
	f_mount(NULL,"0:",1);
}


void CreateDir(void)
{
	res_sd = f_mount(&fs,"0:",1);
	if(res_sd != FR_OK)
	{
		PRINTF_LOG("ļϵͳʧ (%d)\r\n",res_sd);
	}	
	
	res_sd = f_mkdir("/Dir1");
	if(res_sd == FR_OK)
	{
		PRINTF_LOG("f_mkdir Dir1 OK\r\n");
	}
	else if(res_sd == FR_EXIST)
	{
		PRINTF_LOG("Dir1 ĿѴ(%d)\r\n",res_sd);
	}	
	else
	{
		PRINTF_LOG("f_mkdir Dir1 ʧ(%d)\r\n",res_sd);
		return;
	}
	
	res_sd = f_mkdir("/Dir2");
	if(res_sd == FR_OK)
	{
		PRINTF_LOG("f_mkdir Dir2 OK\r\n");
	}
	else if(res_sd == FR_EXIST)
	{
		PRINTF_LOG("Dir2 ĿѴ(%d)\r\n",res_sd);
	}	
	else
	{
		PRINTF_LOG("f_mkdir Dir2 ʧ (%d)\r\n",res_sd);
		return;
	}	
	
	res_sd = f_mkdir("/Dir1/Dir1_1");
	if(res_sd == FR_OK)
	{
		PRINTF_LOG("f_mkdir Dir1_1 OK\r\n");
	}
	else if(res_sd == FR_EXIST)
	{
		PRINTF_LOG("Dir1_1 ĿѴ(%d)\r\n",res_sd);
	}	
	else
	{
		PRINTF_LOG("f_mkdir Dir1_1 ʧ (%d)\r\n",res_sd);
		return;
	}	
		
	f_mount(NULL,"0:",1);
}

void DeleteDirFile(void)
{
	res_sd = f_mount(&fs,"0:",1);
	if(res_sd != FR_OK)
	{
		PRINTF_LOG("ļϵͳʧ (%d)\r\n",res_sd);
	}		
	
	res_sd = f_unlink("/Dir1/Dir1_1");
	if(res_sd == FR_OK)
	{
		PRINTF_LOG("ɾĿ¼/Dir1/Dir1_1ɹ\r\n");
	}
	else if((res_sd == FR_NO_FILE)||(res_sd == FR_NO_PATH))
	{
		PRINTF_LOG("ûзļĿ¼: %s\r\n","/Dir1/Dir1_1");
	}
	else
	{
		PRINTF_LOG("ɾĿ¼/Dir1/Dir1_1ʧ( = %d) ļֻĿ¼ǿ\r\n",res_sd);
	}
	
	res_sd = f_unlink("/Dir1");
	if(res_sd == FR_OK)
	{
		PRINTF_LOG("ɾĿ¼/Dir1ɹ\r\n");
	}
	else if((res_sd == FR_NO_FILE)||(res_sd == FR_NO_PATH))
	{
		PRINTF_LOG("ûзļĿ¼ : %s\r\n","/Dir1");
	}
	else
	{
		PRINTF_LOG("ɾĿ¼/Dir1/Dir1_1ʧ( = %d) ļֻĿ¼ǿ\r\n",res_sd);
	}	
	
	res_sd = f_unlink("/Dir2");
	if(res_sd == FR_OK)
	{
		PRINTF_LOG("ɾ/Dir2ɹ\r\n");
	}
	else if((res_sd == FR_NO_FILE)||(res_sd == FR_NO_PATH))
	{
		PRINTF_LOG("ûзļĿ¼ : %s\r\n","/Dir2");
	}
	else
	{
		PRINTF_LOG("ɾĿ¼/Dir1/Dir1_1ʧ( = %d) ļֻĿ¼ǿ\r\n",res_sd);
	}	
	
	res_sd = f_unlink("FatFsдļ.txt");
	if(res_sd == FR_OK)
	{
		PRINTF_LOG("ɾFatFsдļ.txtɹ\r\n");
	}
	else if((res_sd == FR_NO_FILE)||(res_sd == FR_NO_PATH))
	{
		PRINTF_LOG("ûзļĿ¼ : %s\r\n","/FatFsдļ.txt");
	}
	else
	{
		PRINTF_LOG("ɾFatFsдļ.txtʧ( = %d) ļֻĿ¼ǿ\r\n",res_sd);
	}	

//	res_sd = f_unlink("WriteFileTest????.txt");
//	if(res_sd == FR_OK)
//	{
//		DEBUG("??WriteFileTest????.txt??\r\n");
//	}
//	else if((res_sd == FR_NO_FILE)||(res_sd == FR_NO_PATH))
//	{
//		DEBUG("????????? : %s\r\n","/WriteFileTest????.txt");
//	}
//	else
//	{
//		DEBUG("??WriteFileTest??????(???? = %d) ??????????\r\n",res_sd);
//	}	
//	
//	f_mount(NULL,"0:",1);	
}

void ViewRootDir(void)
{
	DIR dirinf;
	FILINFO fileinf;
	uint32_t cnt = 0;
	char name[256];
	
	res_sd = f_mount(&fs,"0:",1);
	if(res_sd != FR_OK)
	{
		PRINTF_LOG("ļϵͳʧ (%d)\r\n",res_sd);
	}	
	
	res_sd = f_opendir(&dirinf,"/");
	if(res_sd != FR_OK)
	{
		PRINTF_LOG("򿪸Ŀ¼ʧ (%d)\r\n",res_sd);
		return;
	}
	
	fileinf.lfname = name;
	fileinf.lfsize = 256;
	
	PRINTF_LOG("		|	ļС	|	ļ	|	ļ\r\n");
	for(cnt =0; ;cnt++)
	{
		res_sd = f_readdir(&dirinf,&fileinf);
		if(res_sd != FR_OK || fileinf.fname[0] == 0)
		{
			break;
		}
		
		if(fileinf.fname[0] == '.')
		{
			continue;
		}
		
		if(fileinf.fattrib & AM_DIR)
		{
			PRINTF_LOG("(0x%02d)Ŀ¼",fileinf.fattrib);
		}
		else
		{
			PRINTF_LOG("(0x%02d)",fileinf.fattrib);
		}
		
		PRINTF_LOG("%10d	",fileinf.fsize);
		PRINTF_LOG("	%s |",fileinf.fname);
		PRINTF_LOG("	%s\r\n",(char *)fileinf.lfname);
	}
	
	f_mount(NULL,"0:",1);
}

int SER_PutChar (int ch)
{
	while(!USART_GetFlagStatus(USART_TEST,USART_FLAG_TC));
	USART_SendData(USART_TEST, (uint8_t) ch);

	return ch;
}

int fputc(int c, FILE *f)
{
	/* Place your implementation of fputc here */
	/* e.g. write a character to the USART */
	if (c == '\n')
	{
		SER_PutChar('\r');
	}
	return (SER_PutChar(c));
}

