#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "tpad.h"
#include "delay.h"		    

#define TPAD_ARR_MAX_VAL 	0XFFFF	//ARRֵ
#ifdef PIN48_BOARD
#define TIM_INPUT_CHANNEL 	TIM_Channel_3
#define TIM_INPUT_STATE		TIM_IT_CC3
#endif

#ifdef PIN64_BOARD
#define TIM_INPUT_CHANNEL 	TIM_Channel_2
#define TIM_INPUT_STATE		TIM_IT_CC2
#endif

vu16 tpad_default_val=0;//صʱ(ûְ),Ҫʱ


//ʼ
//ÿصʱȡֵ.
//ֵ:0,ʼɹ;1,ʼʧ
u8 TPAD_Init(u8 psc)
{
	u16 buf[10];
	u16 temp;
	u8 j,i;
	TIM_Cap_Init(TPAD_ARR_MAX_VAL,psc-1);//1MhzƵʼ 
	for(i=0;i<10;i++)//ȡ10
	{				 
		buf[i]=TPAD_Get_Val();
		Delay_Ms(10);	    
	}				    
	for(i=0;i<9;i++)//
	{
		for(j=i+1;j<10;j++)
		{
			if(buf[i]>buf[j])//
			{
				temp=buf[i];
				buf[i]=buf[j];
				buf[j]=temp;
			}
		}
	}
	temp=0;
	for(i=2;i<8;i++)temp+=buf[i];//ȡм6ݽƽ
	tpad_default_val=temp/6;
	PRINTF_LOG("tpad_default_val:%d\r\n",tpad_default_val);	
	if(tpad_default_val>TPAD_ARR_MAX_VAL/2)return 1;//ʼTPAD_ARR_MAX_VAL/2ֵ,!
	return 0;		     	    					   
}
//λһ
void TPAD_Reset(void)
{
  	GPIO_InitTypeDef  GPIO_InitStructure; 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);	 //ʹPA˿ʱ
	
#ifdef PIN48_BOARD
 	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;				 //PA2˿
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOA, &GPIO_InitStructure);
 	GPIO_ResetBits(GPIOA,GPIO_Pin_2);						 //PA20,ŵ
#endif
	
#ifdef PIN64_BOARD
 	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;				 
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOA, &GPIO_InitStructure);
 	GPIO_ResetBits(GPIOA,GPIO_Pin_1);
#endif
	
	Delay_Ms(5);

	TIM_SetCounter(TIM2,0);
	TIM_ClearITPendingBit(TIM2, TIM_INPUT_STATE|TIM_IT_Update); //жϱ־

	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IN_FLOATING;	 //
	GPIO_Init(GPIOA, &GPIO_InitStructure);

    
}
//õʱֵ
//ʱ,ֱӷضʱļֵ.
u16 TPAD_Get_Val(void)
{				   
	TPAD_Reset();
	while(TIM_GetFlagStatus(TIM2, TIM_INPUT_STATE) == RESET)//ȴ
	{
		if(TIM_GetCounter(TIM2)>TPAD_ARR_MAX_VAL-500)return TIM_GetCounter(TIM2);//ʱ,ֱӷCNTֵ
	};	
#ifdef PIN48_BOARD
	return TIM_GetCapture3(TIM2);	  
#endif
#ifdef PIN64_BOARD
	return TIM_GetCapture2(TIM2);	  
#endif
} 	 
//ȡn,ȡֵ
//nȡĴ
//ֵnζֵ
u16 TPAD_Get_MaxVal(u8 n)
{
	u16 temp=0;
	u16 res=0;
	while(n--)
	{
		temp=TPAD_Get_Val();//õһֵ
		if(temp>res)res=temp;
	};
	return res;
}  
//ɨ败
//mode:0,֧(һαɿܰһ);1,֧(һֱ)
//ֵ:0,ûа;1,а;										  
#define TPAD_GATE_VAL 	100	//ֵ,ҲǱtpad_default_val+TPAD_GATE_VAL,ΪЧ.
u8 TPAD_Scan(u8 mode)
{
	static u8 keyen=0;	//0,Կʼ;>0,ܿʼ	 
	u8 res=0;
	u8 sample=3;		//ĬϲΪ3	 
	u16 rval;
	if(mode)
	{
		sample=6;		//֧ʱòΪ6
		keyen=0;		//֧	  
	}
	rval=TPAD_Get_MaxVal(sample); 
	if(rval>(tpad_default_val+TPAD_GATE_VAL))//tpad_default_val+TPAD_GATE_VAL,Ч
	{							 
		if(keyen==0)res=1;		//keyen==0,Ч 
		printf("r:%d\r\n",rval);		     	    					   
		keyen=3;				//Ҫٹ3֮ܰЧ   
	} 
	if(keyen)keyen--;		   							   		     	    					   
	return res;
}	

void TIM_Cap_Init(u16 arr,u16 psc)
{
	GPIO_InitTypeDef  GPIO_InitStructure; 
   	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	TIM_ICInitTypeDef  TIM_ICInitStructure;

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);	 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);	 

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;				 
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	
   	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IN_FLOATING;	
	GPIO_Init(GPIOA, &GPIO_InitStructure);	

	TIM_TimeBaseStructure.TIM_Period = arr; 
	TIM_TimeBaseStructure.TIM_Prescaler =psc; 	  
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; 
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure); 

  	TIM_ICInitStructure.TIM_Channel = TIM_INPUT_CHANNEL; 
  	TIM_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Rising;	
  	TIM_ICInitStructure.TIM_ICSelection = TIM_ICSelection_DirectTI; 
  	TIM_ICInitStructure.TIM_ICPrescaler = TIM_ICPSC_DIV1;	
  	TIM_ICInitStructure.TIM_ICFilter = 0x03;
  	TIM_ICInit(TIM2, &TIM_ICInitStructure);

    TIM_Cmd(TIM2,ENABLE );
}













