#include "w25qxx.h" 
#include "delay.h"
#include "mass_mal.h"

u16 W25QXX_TYPE=0;	//ĬW25Q128

uint16_t wq25xx_Flash_Init(void);
uint16_t wq25xx_WriteMultiBlocks(uint32_t Memory_Offset, uint8_t *Writebuff, uint16_t Transfer_Length);
uint16_t wq25xx_ReadMultiBlocks(uint32_t Memory_Offset, uint8_t *Readbuff, uint16_t Transfer_Length);
uint16_t wq25xx_Flash_GetStatus(uint8_t lun);

uint8_t wq25xx_Flash_Inquiry_Data[] =
{
	0x00,          /* Direct Access Device */
	0x80,          /* RMB = 1: Removable Medium */
	0x02,          /* Version: No conformance claim to standard */
	0x02,

	36 - 4,          /* Additional Length */
	0x00,          /* SCCS = 1: Storage Controller Component */
	0x00,
	0x00,
	/* Vendor Identification */
	'M', 'H', ' ', ' ', ' ', ' ', ' ', ' ',
	/* Product Identification */
	'w', 'q', '2', '5', ' ',' ', ' ', ' ', ' ', ' ', ' ', ' ', 
	'D', 'i', 's', 'k',
	/* Product Revision Level */
	'1', '.', '0', ' '
};
  
t_Mal_Lun w25qxx_Flash = 
{
    wq25xx_Flash_Init,
    wq25xx_WriteMultiBlocks,
    wq25xx_ReadMultiBlocks,
    wq25xx_Flash_GetStatus,
	wq25xx_Flash_Inquiry_Data,
};

//SPIx дһֽ
//TxData:Ҫдֽ
//ֵ:ȡֽ
u8 SPI_ReadWriteByte(u8 TxData)
{		
	u8 retry=0;				 	
	while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET) //ָSPI־λ:ͻձ־λ
		{
		retry++;
		if(retry>200)return 0;
		}			  
	SPI_I2S_SendData(SPI2, TxData); //ͨSPIxһ
	retry=0;

	while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET) //ָSPI־λ:ܻǿձ־λ
		{
		retry++;
		if(retry>200)return 0;
		}	  						    
	return SPI_I2S_ReceiveData(SPI2); //ͨSPIxյ					    
}

void SPI_InitTest(void)
{
 	GPIO_InitTypeDef GPIO_InitStructure;
	SPI_InitTypeDef  SPI_InitStructure;

	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOB, ENABLE );//PORTBʱʹ 
	RCC_APB1PeriphClockCmd(	RCC_APB1Periph_SPI2,  ENABLE );//SPI2ʱʹ 	
 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  //PB13/14/15 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼGPIOB

 	GPIO_SetBits(GPIOB,GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15);  //PB13/14/15

	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;  //SPI˫ģʽ:SPIΪ˫˫ȫ˫
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		//SPIģʽ:ΪSPI
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;		//SPIݴС:SPIͽ8λ֡ṹ
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;		//ͬʱӵĿ״̬Ϊߵƽ
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;	//ͬʱӵĵڶأ½ݱ
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;		//NSSźӲNSSܽţʹSSIλ:ڲNSSźSSIλ
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256;		//岨ԤƵֵ:ԤƵֵΪ256
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;	//ָݴMSBλLSBλʼ:ݴMSBλʼ
	SPI_InitStructure.SPI_CRCPolynomial = 7;	//CRCֵĶʽ
	SPI_Init(SPI2, &SPI_InitStructure);  //SPI_InitStructָĲʼSPIxĴ
 
	SPI_Cmd(SPI2, ENABLE); //ʹSPI
	
	SPI_ReadWriteByte(0xff);//		 
 

}   
//SPI ٶú
//SpeedSet:
//SPI_BaudRatePrescaler_2   2Ƶ   
//SPI_BaudRatePrescaler_8   8Ƶ   
//SPI_BaudRatePrescaler_16  16Ƶ  
//SPI_BaudRatePrescaler_256 256Ƶ 
  
void SPI_SetSpeed(u8 SPI_BaudRatePrescaler)
{
	assert_param(IS_SPI_BAUDRATE_PRESCALER(SPI_BaudRatePrescaler));
	SPI2->CR1&=0XFFC7;
	SPI2->CR1|=SPI_BaudRatePrescaler;
	SPI_Cmd(SPI2,ENABLE); 

} 


//4KbytesΪһSector
//16Ϊ1Block
//W25Q128
//Ϊ16Mֽ,128Block,4096Sector 
													 
//ʼSPI FLASHIO
void W25QXX_Init(void)
{	
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOB, ENABLE );

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12; 
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOB, &GPIO_InitStructure);
 	GPIO_SetBits(GPIOB,GPIO_Pin_12);
 
    W25QXX_CS=1;			//SPI FLASHѡ
	SPI_InitTest();		   	//ʼSPI
	SPI_SetSpeed(SPI_BaudRatePrescaler_4);
	W25QXX_TYPE=W25QXX_ReadID();//ȡFLASH ID.  

}  

//ȡW25QXX״̬Ĵ
//BIT7  6   5   4   3   2   1   0
//SPR   RV  TB BP2 BP1 BP0 WEL BUSY
//SPR:Ĭ0,״̬Ĵλ,WPʹ
//TB,BP2,BP1,BP0:FLASHд
//WEL:дʹ
//BUSY:æλ(1,æ;0,)
//Ĭ:0x00
u8 W25QXX_ReadSR(void)   
{  
	u8 byte=0;   
	W25QXX_CS=0;                            //ʹ   
	SPI_ReadWriteByte(W25X_ReadStatusReg); //Ͷȡ״̬Ĵ    
	byte=SPI_ReadWriteByte(0Xff);          //ȡһֽ  
	W25QXX_CS=1;                            //ȡƬѡ     
	return byte;   
} 
//дW25QXX״̬Ĵ
//ֻSPR,TB,BP2,BP1,BP0(bit 7,5,4,3,2)д!!!
void W25QXX_Write_SR(u8 sr)   
{   
	W25QXX_CS=0;                            //ʹ   
	SPI_ReadWriteByte(W25X_WriteStatusReg);//дȡ״̬Ĵ    
	SPI_ReadWriteByte(sr);               	//дһֽ  
	W25QXX_CS=1;                            //ȡƬѡ     	      
}   
//W25QXXдʹ	
//WELλ   
void W25QXX_Write_Enable(void)   
{
	W25QXX_CS=0;                          	//ʹ   
    SPI_ReadWriteByte(W25X_WriteEnable); 	//дʹ  
	W25QXX_CS=1;                           	//ȡƬѡ     	      
} 
//W25QXXдֹ	
//WEL  
void W25QXX_Write_Disable(void)   
{  
	W25QXX_CS=0;                            //ʹ   
    SPI_ReadWriteByte(W25X_WriteDisable);  //дָֹ    
	W25QXX_CS=1;                            //ȡƬѡ     	      
} 		
//ȡоƬID
//ֵ:				   
//0XEF13,ʾоƬͺΪW25Q80  
//0XEF14,ʾоƬͺΪW25Q16    
//0XEF15,ʾоƬͺΪW25Q32  
//0XEF16,ʾоƬͺΪW25Q64 
//0XEF17,ʾоƬͺΪW25Q128 	  
u16 W25QXX_ReadID(void)
{
	u16 Temp = 0;	  
	W25QXX_CS=0;				    
	SPI_ReadWriteByte(0x90);//ͶȡID	    
	SPI_ReadWriteByte(0x00); 	    
	SPI_ReadWriteByte(0x00); 	    
	SPI_ReadWriteByte(0x00); 	 			   
	Temp|=SPI_ReadWriteByte(0xFF)<<8;  
	Temp|=SPI_ReadWriteByte(0xFF);	 
	W25QXX_CS=1;				    
	return Temp;
}   		    
//ȡSPI FLASH  
//ַָʼȡָȵ
//pBuffer:ݴ洢
//ReadAddr:ʼȡĵַ(24bit)
//NumByteToRead:Ҫȡֽ(65535)
void W25QXX_Read(u8* pBuffer,u32 ReadAddr,u16 NumByteToRead)   
{ 
 	u16 i;   										    
	W25QXX_CS=0;                            	//ʹ   
    SPI_ReadWriteByte(W25X_ReadData);         	//Ͷȡ   
    SPI_ReadWriteByte((u8)((ReadAddr)>>16));  	//24bitַ    
    SPI_ReadWriteByte((u8)((ReadAddr)>>8));   
    SPI_ReadWriteByte((u8)ReadAddr);   
    for(i=0;i<NumByteToRead;i++)
	{ 
        pBuffer[i]=SPI_ReadWriteByte(0XFF);   	//ѭ  
    }
	W25QXX_CS=1;  				    	      
}  
//SPIһҳ(0~65535)д256ֽڵ
//ַָʼд256ֽڵ
//pBuffer:ݴ洢
//WriteAddr:ʼдĵַ(24bit)
//NumByteToWrite:Ҫдֽ(256),Ӧóҳʣֽ!!!	 
void W25QXX_Write_Page(u8* pBuffer,u32 WriteAddr,u16 NumByteToWrite)
{
 	u16 i;  
    W25QXX_Write_Enable();                  	//SET WEL 
	W25QXX_CS=0;                            	//ʹ   
    SPI_ReadWriteByte(W25X_PageProgram);      	//дҳ   
    SPI_ReadWriteByte((u8)((WriteAddr)>>16)); 	//24bitַ    
    SPI_ReadWriteByte((u8)((WriteAddr)>>8));   
    SPI_ReadWriteByte((u8)WriteAddr);   
    for(i=0;i<NumByteToWrite;i++)SPI_ReadWriteByte(pBuffer[i]);//ѭд  
	W25QXX_CS=1;                            	//ȡƬѡ 
	W25QXX_Wait_Busy();					   		//ȴд
} 
//޼дSPI FLASH 
//ȷдĵַΧڵȫΪ0XFF,ڷ0XFFдݽʧ!
//Զҳ 
//ַָʼдָȵ,ҪȷַԽ!
//pBuffer:ݴ洢
//WriteAddr:ʼдĵַ(24bit)
//NumByteToWrite:Ҫдֽ(65535)
//CHECK OK
void W25QXX_Write_NoCheck(u8* pBuffer,u32 WriteAddr,u16 NumByteToWrite)   
{ 			 		 
	u16 pageremain;	   
	pageremain=256-WriteAddr%256; //ҳʣֽ		 	    
	if(NumByteToWrite<=pageremain)pageremain=NumByteToWrite;//256ֽ
	while(1)
	{	   
		W25QXX_Write_Page(pBuffer,WriteAddr,pageremain);
		if(NumByteToWrite==pageremain)break;//д
	 	else //NumByteToWrite>pageremain
		{
			pBuffer+=pageremain;
			WriteAddr+=pageremain;	

			NumByteToWrite-=pageremain;			  //ȥѾд˵ֽ
			if(NumByteToWrite>256)pageremain=256; //һοд256ֽ
			else pageremain=NumByteToWrite; 	  //256ֽ
		}
	};	    
} 
//дSPI FLASH  
//ַָʼдָȵ
//ú!
//pBuffer:ݴ洢
//WriteAddr:ʼдĵַ(24bit)						
//NumByteToWrite:Ҫдֽ(65535)   
u8 W25QXX_BUFFER[4096];		 
void W25QXX_Write(u8* pBuffer,u32 WriteAddr,u16 NumByteToWrite)   
{ 
	u32 secpos;
	u16 secoff;
	u16 secremain;	   
 	u16 i;    
	u8 * W25QXX_BUF;	  
   	W25QXX_BUF=W25QXX_BUFFER;	     
 	secpos=WriteAddr/4096;//ַ  
	secoff=WriteAddr%4096;//ڵƫ
	secremain=4096-secoff;//ʣռС   
 	//printf("ad:%X,nb:%X\r\n",WriteAddr,NumByteToWrite);//
 	if(NumByteToWrite<=secremain)secremain=NumByteToWrite;//4096ֽ
	while(1) 
	{	
		W25QXX_Read(W25QXX_BUF,secpos*4096,4096);//
		for(i=0;i<secremain;i++)//У
		{
			if(W25QXX_BUF[secoff+i]!=0XFF)break;//Ҫ  	  
		}
		if(i<secremain)//Ҫ
		{
			W25QXX_Erase_Sector(secpos);		//
			for(i=0;i<secremain;i++)	   		//
			{
				W25QXX_BUF[i+secoff]=pBuffer[i];	  
			}
			W25QXX_Write_NoCheck(W25QXX_BUF,secpos*4096,4096);//д  

		}else W25QXX_Write_NoCheck(pBuffer,WriteAddr,secremain);//дѾ˵,ֱдʣ. 				   
		if(NumByteToWrite==secremain)break;//д
		else//дδ
		{
			secpos++;//ַ1
			secoff=0;//ƫλΪ0 	 

		   	pBuffer+=secremain;  				//ָƫ
			WriteAddr+=secremain;				//дַƫ	   
		   	NumByteToWrite-=secremain;			//ֽݼ
			if(NumByteToWrite>4096)secremain=4096;//һд
			else secremain=NumByteToWrite;		//һд
		}	 
	};	 
}
//оƬ		  
//ȴʱ䳬...
void W25QXX_Erase_Chip(void)   
{                                   
    W25QXX_Write_Enable();                 	 	//SET WEL 
    W25QXX_Wait_Busy();   
  	W25QXX_CS=0;                            	//ʹ   
    SPI_ReadWriteByte(W25X_ChipErase);        	//Ƭ  
	W25QXX_CS=1;                            	//ȡƬѡ     	      
	W25QXX_Wait_Busy();   				   		//ȴоƬ
}   
//һ
//Dst_Addr:ַ ʵ
//һɽʱ:150ms
void W25QXX_Erase_Sector(u32 Dst_Addr)   
{  
	//falsh,     
 	Dst_Addr*=4096;
    W25QXX_Write_Enable();                  	//SET WEL 	 
    W25QXX_Wait_Busy();   
  	W25QXX_CS=0;                            	//ʹ   
    SPI_ReadWriteByte(W25X_SectorErase);      	//ָ 
    SPI_ReadWriteByte((u8)((Dst_Addr)>>16));  	//24bitַ    
    SPI_ReadWriteByte((u8)((Dst_Addr)>>8));   
    SPI_ReadWriteByte((u8)Dst_Addr);  
	W25QXX_CS=1;                            	//ȡƬѡ     	      
    W25QXX_Wait_Busy();   				   		//ȴ
}  
//ȴ
void W25QXX_Wait_Busy(void)   
{   
	while((W25QXX_ReadSR()&0x01)==0x01);  		// ȴBUSYλ
}  
//ģʽ
void W25QXX_PowerDown(void)   
{ 
  	W25QXX_CS=0;                           	 	//ʹ   
    SPI_ReadWriteByte(W25X_PowerDown);        //͵  
	W25QXX_CS=1;                            	//ȡƬѡ     	      
    Delay_Us(3);                               //ȴTPD  
}   
//
void W25QXX_WAKEUP(void)   
{  
  	W25QXX_CS=0;                            	//ʹ   
    SPI_ReadWriteByte(W25X_ReleasePowerDown);	//  send W25X_PowerDown command 0xAB    
	W25QXX_CS=1;                            	//ȡƬѡ     	      
    Delay_Us(3);                            	//ȴTRES1
}   

uint16_t wq25xx_Flash_Init(void)
{
	W25QXX_Init();
    return MAL_OK;
}

uint16_t wq25xx_WriteMultiBlocks(uint32_t Memory_Offset, uint8_t *Writebuff, uint16_t Transfer_Length)
{
	W25QXX_Erase_Sector(Memory_Offset);
	W25QXX_Write_NoCheck(Writebuff,Memory_Offset,Transfer_Length);
    return MAL_OK;
}

uint16_t wq25xx_ReadMultiBlocks(uint32_t Memory_Offset, uint8_t *Readbuff, uint16_t Transfer_Length)
{
	W25QXX_Read(Readbuff,Memory_Offset,Transfer_Length);
    return MAL_OK;
}

uint16_t wq25xx_Flash_GetStatus(uint8_t lun)
{
	if((W25QXX_TYPE & 0xFF) == 0x13)
		Mass_Block_Count[lun] = 0x100000 / 0x1000;
	else if((W25QXX_TYPE & 0xFF) == 0x14)
		Mass_Block_Count[lun] = 0x200000 / 0x1000;
	else if((W25QXX_TYPE & 0xFF) == 0x15)
		Mass_Block_Count[lun] = 0x400000 / 0x1000;
	else if((W25QXX_TYPE & 0xFF) == 0x16)
		Mass_Block_Count[lun] = 0x800000 / 0x1000;
	else if((W25QXX_TYPE & 0xFF) == 0x17)
		Mass_Block_Count[lun] = 0x1000000 / 0x1000;
	else
		return MAL_FAIL;
    Mass_Block_Size[lun] = 0x1000;
    return MAL_OK;
}
